﻿// CodeGear C++Builder
// Copyright (c) 1995, 2016 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ZylNMEAGenerator.pas' rev: 31.00 (Windows)

#ifndef ZylnmeageneratorHPP
#define ZylnmeageneratorHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <System.Classes.hpp>
#include <System.Win.Registry.hpp>
#include <Winapi.Windows.hpp>
#include <System.IniFiles.hpp>
#include <Vcl.Graphics.hpp>
#include <System.Contnrs.hpp>
#include <System.Math.hpp>
#include <System.SyncObjs.hpp>
#include <Vcl.Dialogs.hpp>
#include <Vcl.Forms.hpp>
#include <System.SysUtils.hpp>
#include <System.UITypes.hpp>

//-- user supplied -----------------------------------------------------------

namespace Zylnmeagenerator
{
//-- forward type declarations -----------------------------------------------
class DELPHICLASS TSatellite;
class DELPHICLASS TWayPoint;
class DELPHICLASS TWayPoints;
class DELPHICLASS TRoute;
class DELPHICLASS TRoutes;
class DELPHICLASS TZylNMEAGenerator;
class DELPHICLASS TSenderThread;
class DELPHICLASS EZylNMEAException;
//-- type declarations -------------------------------------------------------
enum DECLSPEC_DENUM TCardinalPoint : unsigned char { cpNorth, cpSouth, cpEast, cpWest };

enum DECLSPEC_DENUM Zylnmeagenerator__1 : unsigned char { GPGLL, GPGGA, GPVTG, GPRMC, GPGSA, GPGSV, GPZDA, GPWPL, GPRTE, GPAAM, AllNMEA };

typedef System::Set<Zylnmeagenerator__1, Zylnmeagenerator__1::GPGLL, Zylnmeagenerator__1::AllNMEA> TNMEACommands;

enum DECLSPEC_DENUM TSatelliteType : unsigned char { GpsSatellite, GlonassSatellite, BeidouSatellite };

#pragma pack(push,4)
class PASCALIMPLEMENTATION TSatellite : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	System::Word FPseudoRandomCode;
	bool FActive;
	int FAzimuth;
	int FElevation;
	int FSignalToNoiseRatio;
	TSatelliteType FSatelliteType;
	void __fastcall SetAzimuth(const int Value);
	void __fastcall SetElevation(const int Value);
	void __fastcall SetSignalToNoiseRatio(const int Value);
	
public:
	__property System::Word PseudoRandomCode = {read=FPseudoRandomCode, nodefault};
	__property bool Active = {read=FActive, write=FActive, nodefault};
	__property int Azimuth = {read=FAzimuth, write=SetAzimuth, nodefault};
	__property int Elevation = {read=FElevation, write=SetElevation, nodefault};
	__property int SignalToNoiseRatio = {read=FSignalToNoiseRatio, write=SetSignalToNoiseRatio, nodefault};
	__property TSatelliteType SatelliteType = {read=FSatelliteType, write=FSatelliteType, nodefault};
	__fastcall TSatellite(System::Word p_PseudoRandomCode);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TSatellite(void) { }
	
};

#pragma pack(pop)

typedef System::StaticArray<TSatellite*, 235> TSatellites;

class PASCALIMPLEMENTATION TWayPoint : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	System::AnsiString FName;
	int FLatDeg;
	int FLatMin;
	System::Extended FLatSec;
	TCardinalPoint FLatDir;
	TCardinalPoint FLongDir;
	int FLongDeg;
	int FLongMin;
	System::Extended FLongSec;
	void __fastcall SetLatDeg(const int Value);
	void __fastcall SetLatMin(const int Value);
	void __fastcall SetLatSec(const System::Extended Value);
	void __fastcall SetLatDir(const TCardinalPoint Value);
	void __fastcall SetLongDeg(const int Value);
	void __fastcall SetLongMin(const int Value);
	void __fastcall SetLongSec(const System::Extended Value);
	void __fastcall SetLongDir(const TCardinalPoint Value);
	
public:
	__fastcall TWayPoint(const System::AnsiString WayPointName);
	__property System::AnsiString Name = {read=FName, write=FName};
	__property int Latitude_Degree = {read=FLatDeg, write=SetLatDeg, nodefault};
	__property int Latitude_Minute = {read=FLatMin, write=SetLatMin, nodefault};
	__property System::Extended Latitude_Second = {read=FLatSec, write=SetLatSec};
	__property TCardinalPoint Latitude_Direction = {read=FLatDir, write=SetLatDir, nodefault};
	__property int Longitude_Degree = {read=FLongDeg, write=SetLongDeg, nodefault};
	__property int Longitude_Minute = {read=FLongMin, write=SetLongMin, nodefault};
	__property System::Extended Longitude_Second = {read=FLongSec, write=SetLongSec};
	__property TCardinalPoint Longitude_Direction = {read=FLongDir, write=SetLongDir, nodefault};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TWayPoint(void) { }
	
};


#pragma pack(push,4)
class PASCALIMPLEMENTATION TWayPoints : public System::TObject
{
	typedef System::TObject inherited;
	
public:
	TWayPoint* operator[](int Index) { return this->Items[Index]; }
	
private:
	System::Contnrs::TObjectList* fItems;
	TWayPoint* __fastcall GetItem(int Idx);
	void __fastcall SetItem(int Idx, TWayPoint* const Item);
	int __fastcall GetCount(void);
	
public:
	__property int Count = {read=GetCount, nodefault};
	__property TWayPoint* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
	__fastcall TWayPoints(void);
	void __fastcall Dispose(bool DisposeItems);
	HIDESBASE void __fastcall Free(void);
	void __fastcall Add(TWayPoint* const Item);
	void __fastcall Insert(int Idx, TWayPoint* const Item);
	void __fastcall Delete(int Idx, bool DisposeItems)/* overload */;
	void __fastcall Delete(int Idx)/* overload */;
	void __fastcall Delete(const System::AnsiString WayPointName)/* overload */;
	void __fastcall Delete(const System::AnsiString WayPointName, bool DisposeItems)/* overload */;
	void __fastcall Clear(bool DisposeItems)/* overload */;
	void __fastcall Clear(void)/* overload */;
	void __fastcall Swap(const System::AnsiString SourceName, const System::AnsiString DestinationName);
	int __fastcall IndexOf(const System::AnsiString WayPointName);
	TWayPoint* __fastcall GetByName(const System::AnsiString WayPointName);
	void __fastcall SaveToFile(const System::UnicodeString FileName);
	void __fastcall LoadFromFile(const System::UnicodeString FileName);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TWayPoints(void) { }
	
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TRoute : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	System::AnsiString FName;
	System::Classes::TStringList* FWayPoints;
	System::AnsiString __fastcall GetDestination(void);
	
public:
	__property System::AnsiString Name = {read=FName, write=FName};
	__property System::Classes::TStringList* WayPoints = {read=FWayPoints, write=FWayPoints};
	__property System::AnsiString Destination = {read=GetDestination};
	__fastcall TRoute(const System::AnsiString RouteName);
	__fastcall virtual ~TRoute(void);
	void __fastcall SaveToFile(const System::UnicodeString FileName);
	void __fastcall LoadFromFile(const System::UnicodeString FileName);
	System::AnsiString __fastcall WayPointListToStr(void);
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TRoutes : public System::TObject
{
	typedef System::TObject inherited;
	
public:
	TRoute* operator[](int Index) { return this->Items[Index]; }
	
private:
	System::Contnrs::TObjectList* fItems;
	TRoute* FActiveRoute;
	TRoute* __fastcall GetItem(int Idx);
	void __fastcall SetItem(int Idx, TRoute* const Item);
	int __fastcall GetCount(void);
	
public:
	__property int Count = {read=GetCount, nodefault};
	__property TRoute* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
	__property TRoute* ActiveRoute = {read=FActiveRoute, write=FActiveRoute};
	__fastcall TRoutes(void);
	__fastcall virtual ~TRoutes(void);
	void __fastcall Add(TRoute* const Item);
	void __fastcall Insert(int Idx, TRoute* const Item);
	void __fastcall Delete(int Idx)/* overload */;
	void __fastcall Delete(const System::AnsiString RouteName)/* overload */;
	void __fastcall Clear(void);
	int __fastcall IndexOf(const System::AnsiString RouteName);
	void __fastcall Swap(const System::AnsiString SourceName, const System::AnsiString DestinationName);
	TRoute* __fastcall GetByName(const System::AnsiString RouteName);
};

#pragma pack(pop)

class PASCALIMPLEMENTATION TZylNMEAGenerator : public System::Classes::TComponent
{
	typedef System::Classes::TComponent inherited;
	
private:
	bool FRegistered;
	int FLatDeg;
	int FLatMin;
	System::Extended FLatSec;
	TCardinalPoint FLatDir;
	TCardinalPoint FLongDir;
	int FLongDeg;
	int FLongMin;
	System::Extended FLongSec;
	System::Extended FSpeed;
	System::Extended FHeading;
	System::Extended FAltitude;
	System::Extended FMagnetic_Variation;
	System::Extended FMagnetic_Heading;
	TCardinalPoint FMagnetic_Variation_Direction;
	System::Extended FPDOP;
	System::Extended FHDOP;
	System::Extended FVDOP;
	System::Extended FGeo_Height;
	System::TDateTime FUTCDateTime;
	int FFixQuality;
	int FTotalSatellitesCount;
	TNMEACommands FCommands;
	TSatellites FSatellites;
	TWayPoints* FWayPoints;
	TRoutes* FRoutes;
	bool FUseSystemDateTime;
	bool FMessageAlert;
	double FVersion;
	System::AnsiString FCommPort;
	int FBaudRate;
	NativeUInt ComDevice;
	System::Syncobjs::TCriticalSection* FCriticalSection;
	System::Classes::TThread* FSenderThread;
	double __fastcall RRound(double value);
	System::AnsiString __fastcall ReplaceDecimalSeparatorEx(const System::AnsiString s, const System::AnsiString DS);
	System::AnsiString __fastcall GetNMEACheckSum(const System::AnsiString strNMEA);
	System::AnsiString __fastcall MaxLenStr(const System::AnsiString s, int MaxLen, char c);
	System::AnsiString __fastcall MaxLenStrInv(const System::AnsiString s, int MaxLen, char c);
	System::AnsiString __fastcall GetUTCDateStr(void);
	System::AnsiString __fastcall GetCommaSeparatedUTCDateStr(void);
	System::AnsiString __fastcall GetUTCTimeStr(void);
	System::TDateTime __fastcall GetUTCDateTime(void);
	System::AnsiString __fastcall GetLatitudeStr(void);
	System::AnsiString __fastcall GetLongitudeStr(void);
	System::AnsiString __fastcall GetMagneticVariationDirectionStr(void);
	void __fastcall SetLatDeg(const int Value);
	void __fastcall SetLatMin(const int Value);
	void __fastcall SetLatSec(const System::Extended Value);
	void __fastcall SetLatDir(const TCardinalPoint Value);
	void __fastcall SetLongDeg(const int Value);
	void __fastcall SetLongMin(const int Value);
	void __fastcall SetLongSec(System::Extended Value);
	void __fastcall SetLongDir(const TCardinalPoint Value);
	void __fastcall SetHeading(const System::Extended Value);
	void __fastcall SetMagneticHeading(const System::Extended Value);
	void __fastcall SetMagneticVariation(const System::Extended Value);
	void __fastcall SetMagnetic_Variation_Direction(const TCardinalPoint Value);
	void __fastcall SetHDOP(const System::Extended Value);
	void __fastcall SetVDOP(const System::Extended Value);
	void __fastcall SetPDOP(const System::Extended Value);
	System::Classes::TList* __fastcall GetActiveSatellitesList(void);
	System::Classes::TList* __fastcall GetActiveSatellitesListbyType(TSatelliteType satType);
	bool __fastcall RunningInTheIDE(void);
	
public:
	__property double Version = {read=FVersion};
	__property int TotalSatellitesCount = {read=FTotalSatellitesCount, nodefault};
	__property TWayPoints* WayPoints = {read=FWayPoints, write=FWayPoints};
	__property TRoutes* Routes = {read=FRoutes, write=FRoutes};
	__fastcall virtual TZylNMEAGenerator(System::Classes::TComponent* AOwner);
	__fastcall virtual ~TZylNMEAGenerator(void);
	System::AnsiString __fastcall GetNMEA(void);
	System::AnsiString __fastcall GetGPZDA(void);
	System::AnsiString __fastcall GetGPGGA(void);
	System::AnsiString __fastcall GetGPGLL(void);
	System::AnsiString __fastcall GetGPGSA(void);
	System::AnsiString __fastcall GetGPRMC(void);
	System::AnsiString __fastcall GetGPVTG(void);
	System::AnsiString __fastcall GetGPGSV(void);
	System::AnsiString __fastcall GetGPWPL(void);
	System::AnsiString __fastcall GetGPRTE(void);
	System::AnsiString __fastcall GetGPAAM(void);
	System::Extended __fastcall GetLatitudeAsDecimalDegrees(void);
	System::Extended __fastcall GetLongitudeAsDecimalDegrees(void);
	System::Extended __fastcall KmhToKnots(System::Extended pSpeed);
	System::Extended __fastcall KnotsToKmh(System::Extended pSpeed);
	System::Extended __fastcall KmToMiles(System::Extended pDist);
	System::Extended __fastcall MilesToKm(System::Extended pDist);
	System::Extended __fastcall MetersToFeet(System::Extended pDist);
	System::Extended __fastcall FeetToMeters(System::Extended pDist);
	System::Extended __fastcall DMSToDecimalDegrees(int Degree, int Minute, System::Extended Second, TCardinalPoint Direction);
	System::Extended __fastcall DMSToRadians(int Degree, int Minute, System::Extended Second, TCardinalPoint Direction);
	void __fastcall LatitudeDecimalDegreesToDMS(System::Extended DecDegree, int &Degree, int &Minute, System::Extended &Second, TCardinalPoint &Direction);
	void __fastcall LongitudeDecimalDegreesToDMS(System::Extended DecDegree, int &Degree, int &Minute, System::Extended &Second, TCardinalPoint &Direction);
	void __fastcall DMSToDM(int dmsDegree, int dmsMinute, System::Extended dmsSecond, int &Degree, System::Extended &Minute);
	void __fastcall DMToDMS(int dmDegree, System::Extended dmMinute, int &Degree, int &Minute, System::Extended &Second);
	System::Extended __fastcall KmToNauticalMiles(System::Extended pDist);
	System::Extended __fastcall Distance_KM(int Latitude_Degree1, int Latitude_Minute1, System::Extended Latitude_Second1, TCardinalPoint Latitude_Direction1, int Longitude_Degree1, int Longitude_Minute1, System::Extended Longitude_Second1, TCardinalPoint Longitude_Direction1, int Latitude_Degree2, int Latitude_Minute2, System::Extended Latitude_Second2, TCardinalPoint Latitude_Direction2, int Longitude_Degree2, int Longitude_Minute2, System::Extended Longitude_Second2, TCardinalPoint Longitude_Direction2);
	bool __fastcall Connect(const System::AnsiString SerialPortName, int BaudRateValue)/* overload */;
	bool __fastcall Connect(const System::AnsiString SerialPortName)/* overload */;
	bool __fastcall Connect(void)/* overload */;
	bool __fastcall IsConnected(void);
	void __fastcall Disconnect(void);
	unsigned __fastcall Send(System::AnsiString str);
	void __fastcall SendOnNewThread(System::AnsiString str);
	unsigned __fastcall Transmit(void);
	void __fastcall TransmitOnNewThread(void);
	System::AnsiString __fastcall GetSerialPort(void);
	int __fastcall GetBaudRate(void);
	bool __fastcall SetDCBState(const int BaudRateValue = 0x12c0);
	void __fastcall AddSecondsToLatitude(System::Extended seconds);
	void __fastcall AddSecondsToLongitude(System::Extended seconds);
	void __fastcall SetSatellite(System::Word p_PseudoRandomCode, bool p_Active = true, int p_Elevation = 0x0, int p_Azimuth = 0x0, int p_SignalToNoiseRatio = 0x0, TSatelliteType p_SatelliteType = (TSatelliteType)(0x0));
	System::Word __fastcall GetActiveSatellitesCount(void);
	System::Classes::TList* __fastcall GetSatellitesList(void);
	void __fastcall SaveSatellitesToFile(const System::UnicodeString FileName);
	void __fastcall LoadSatellitesFromFile(const System::UnicodeString FileName);
	void __fastcall ResetSatellites(void);
	void __fastcall DrawSatellites(Vcl::Graphics::TCanvas* Canvas, int Radius, const System::Uitypes::TColor BrushColor, const System::Uitypes::TColor PenColor);
	System::AnsiString __fastcall SatelliteTypeToStr(TSatelliteType sat);
	TSatelliteType __fastcall StrToSatelliteType(System::AnsiString sat);
	
__published:
	__property int Latitude_Degree = {read=FLatDeg, write=SetLatDeg, nodefault};
	__property int Latitude_Minute = {read=FLatMin, write=SetLatMin, nodefault};
	__property System::Extended Latitude_Second = {read=FLatSec, write=SetLatSec};
	__property TCardinalPoint Latitude_Direction = {read=FLatDir, write=SetLatDir, nodefault};
	__property int Longitude_Degree = {read=FLongDeg, write=SetLongDeg, nodefault};
	__property int Longitude_Minute = {read=FLongMin, write=SetLongMin, nodefault};
	__property System::Extended Longitude_Second = {read=FLongSec, write=SetLongSec};
	__property TCardinalPoint Longitude_Direction = {read=FLongDir, write=SetLongDir, nodefault};
	__property System::Extended Altitude = {read=FAltitude, write=FAltitude};
	__property System::Extended Heading = {read=FHeading, write=SetHeading};
	__property System::Extended Speed = {read=FSpeed, write=FSpeed};
	__property System::Extended PDOP = {read=FPDOP, write=SetPDOP};
	__property System::Extended HDOP = {read=FHDOP, write=SetHDOP};
	__property System::Extended VDOP = {read=FVDOP, write=SetVDOP};
	__property System::Extended Geo_Height = {read=FGeo_Height, write=FGeo_Height};
	__property System::Extended Magnetic_Variation = {read=FMagnetic_Variation, write=SetMagneticVariation};
	__property TCardinalPoint Magnetic_Variation_Direction = {read=FMagnetic_Variation_Direction, write=SetMagnetic_Variation_Direction, nodefault};
	__property System::Extended Magnetic_Heading = {read=FMagnetic_Heading, write=SetMagneticHeading};
	__property System::TDateTime UTCDateTime = {read=FUTCDateTime, write=FUTCDateTime};
	__property TNMEACommands Commands = {read=FCommands, write=FCommands, nodefault};
	__property bool UseSystemDateTime = {read=FUseSystemDateTime, write=FUseSystemDateTime, default=1};
	__property bool MessageAlert = {read=FMessageAlert, write=FMessageAlert, default=1};
	__property int FixQuality = {read=FFixQuality, write=FFixQuality, default=0};
	__property System::AnsiString Port = {read=FCommPort, write=FCommPort};
	__property int BaudRate = {read=FBaudRate, write=FBaudRate, nodefault};
};


class PASCALIMPLEMENTATION TSenderThread : public System::Classes::TThread
{
	typedef System::Classes::TThread inherited;
	
private:
	TZylNMEAGenerator* Owner;
	System::AnsiString FBuffer;
	
protected:
	virtual void __fastcall Execute(void);
	
public:
	__property System::AnsiString Buffer = {read=FBuffer, write=FBuffer};
	__fastcall TSenderThread(TZylNMEAGenerator* AOwner);
	__fastcall virtual ~TSenderThread(void);
};


#pragma pack(push,4)
class PASCALIMPLEMENTATION EZylNMEAException : public System::Sysutils::Exception
{
	typedef System::Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ inline __fastcall EZylNMEAException(const System::UnicodeString Msg) : System::Sysutils::Exception(Msg) { }
	/* Exception.CreateFmt */ inline __fastcall EZylNMEAException(const System::UnicodeString Msg, const System::TVarRec *Args, const int Args_High) : System::Sysutils::Exception(Msg, Args, Args_High) { }
	/* Exception.CreateRes */ inline __fastcall EZylNMEAException(NativeUInt Ident)/* overload */ : System::Sysutils::Exception(Ident) { }
	/* Exception.CreateRes */ inline __fastcall EZylNMEAException(System::PResStringRec ResStringRec)/* overload */ : System::Sysutils::Exception(ResStringRec) { }
	/* Exception.CreateResFmt */ inline __fastcall EZylNMEAException(NativeUInt Ident, const System::TVarRec *Args, const int Args_High)/* overload */ : System::Sysutils::Exception(Ident, Args, Args_High) { }
	/* Exception.CreateResFmt */ inline __fastcall EZylNMEAException(System::PResStringRec ResStringRec, const System::TVarRec *Args, const int Args_High)/* overload */ : System::Sysutils::Exception(ResStringRec, Args, Args_High) { }
	/* Exception.CreateHelp */ inline __fastcall EZylNMEAException(const System::UnicodeString Msg, int AHelpContext) : System::Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ inline __fastcall EZylNMEAException(const System::UnicodeString Msg, const System::TVarRec *Args, const int Args_High, int AHelpContext) : System::Sysutils::Exception(Msg, Args, Args_High, AHelpContext) { }
	/* Exception.CreateResHelp */ inline __fastcall EZylNMEAException(NativeUInt Ident, int AHelpContext)/* overload */ : System::Sysutils::Exception(Ident, AHelpContext) { }
	/* Exception.CreateResHelp */ inline __fastcall EZylNMEAException(System::PResStringRec ResStringRec, int AHelpContext)/* overload */ : System::Sysutils::Exception(ResStringRec, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ inline __fastcall EZylNMEAException(System::PResStringRec ResStringRec, const System::TVarRec *Args, const int Args_High, int AHelpContext)/* overload */ : System::Sysutils::Exception(ResStringRec, Args, Args_High, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ inline __fastcall EZylNMEAException(NativeUInt Ident, const System::TVarRec *Args, const int Args_High, int AHelpContext)/* overload */ : System::Sysutils::Exception(Ident, Args, Args_High, AHelpContext) { }
	/* Exception.Destroy */ inline __fastcall virtual ~EZylNMEAException(void) { }
	
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
#define RADIUS_EARTH  (6.378140E+03)
extern DELPHI_PACKAGE void __fastcall Register(void);
}	/* namespace Zylnmeagenerator */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_ZYLNMEAGENERATOR)
using namespace Zylnmeagenerator;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// ZylnmeageneratorHPP
